#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "drzewo.h"

struct drzewo* dodaj(struct drzewo *d,char *slowo)
{
	struct drzewo *wezel=NULL;
	if(!d)
	{
		// tworzenie nowego wezla wezel;
		if((wezel=(struct drzewo*)malloc(sizeof(struct drzewo)))==NULL) return NULL;
		else
		{
			wezel->slowo=(char*)malloc(strlen(slowo)+1);
			strcpy(wezel->slowo,slowo);
			wezel->ilosc=1;
			wezel->left=wezel->right=NULL;
		}

		return wezel;
		
	}
	if(strcmp(d->slowo,slowo)==0)      
	{
		d->ilosc++;
		return d;
	}
	if(strcmp(d->slowo,slowo)>0) d->left=dodaj(d->left,slowo);
	else d->right=dodaj(d->right,slowo);

	return d;
}
void wyswietl(struct drzewo *d)
{
	if(!d) return ;
	wyswietl(d->left);
	printf("%20s %d\n",d->slowo,d->ilosc);
	wyswietl(d->right);
	
}

void zwolnij(struct drzewo *d)
{
	if(!d) return ;
	zwolnij(d->left);
	zwolnij(d->right);
	free(d->slowo);
	free(d);
}